﻿// Copyright (c) 2020 Tudor Stanciu

using Newtonsoft.Json;
using System;
using System.Collections.Generic;

namespace Tuitio.Domain.Models
{
    public class TokenExtension
    {
        public Token Token { get; set; }
        public IEnumerable<RecordIdentifier> UserRoles { get; set; }
        public IEnumerable<RecordIdentifier> UserGroups { get; set; }

        [Obsolete("This constructor is only used for deserialization and should not be used for any other purpose.")]
        public TokenExtension() { }

        private TokenExtension(Token token, IEnumerable<RecordIdentifier> userRoles, IEnumerable<RecordIdentifier> userGroups)
        {
            Token=token;
            UserRoles=userRoles;
            UserGroups=userGroups;
        }

        public static TokenExtension Create(Token token, IEnumerable<RecordIdentifier> userRoles, IEnumerable<RecordIdentifier> userGroups)
            => new(token, userRoles, userGroups);

        public string Serialize()
        {
            var text = JsonConvert.SerializeObject(this);
            return text;
        }

        public static TokenExtension Deserialize(string text)
        {
            var token = JsonConvert.DeserializeObject<TokenExtension>(text);
            return token;
        }
    }
}
